# coding: utf-8

"""
    spacestudio satellite API documentation

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.13
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from importlib import import_module
from pydantic import BaseModel, ConfigDict, StrictStr, field_validator
from typing import Any, ClassVar, Dict, List, Optional, Union
from typing import Optional, Set
from typing_extensions import Self

from typing import TYPE_CHECKING
if TYPE_CHECKING:
    from spacestudio_satellite_client.models.deorbitation import Deorbitation
    from spacestudio_satellite_client.models.leo_station_keeping import LeoStationKeeping
    from spacestudio_satellite_client.models.orbital_transfer import OrbitalTransfer
    from spacestudio_satellite_client.models.orbit_phasing import OrbitPhasing
    from spacestudio_satellite_client.models.orbit_propagation import OrbitPropagation
    from spacestudio_satellite_client.models.raan_phasing import RaanPhasing

class Maneuver(BaseModel):
    """
    Maneuver
    """ # noqa: E501
    type: Optional[StrictStr] = None
    __properties: ClassVar[List[str]] = ["type"]

    @field_validator('type')
    def type_validate_enum(cls, value):
        """Validates the enum"""
        if value is None:
            return value

        if value not in set(['ORBITAL_TRANSFER', 'RAAN_PHASING', 'ORBIT_PHASING', 'LEO_STATION_KEEPING', 'DEORBITATION', 'ORBIT_PROPAGATION']):
            raise ValueError("must be one of enum values ('ORBITAL_TRANSFER', 'RAAN_PHASING', 'ORBIT_PHASING', 'LEO_STATION_KEEPING', 'DEORBITATION', 'ORBIT_PROPAGATION')")
        return value

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    # JSON field name that stores the object type
    __discriminator_property_name: ClassVar[str] = 'type'

    # discriminator mappings
    __discriminator_value_class_map: ClassVar[Dict[str, str]] = {
        'DEORBITATION': 'Deorbitation','LEO_STATION_KEEPING': 'LeoStationKeeping','ORBITAL_TRANSFER': 'OrbitalTransfer','ORBIT_PHASING': 'OrbitPhasing','ORBIT_PROPAGATION': 'OrbitPropagation','RAAN_PHASING': 'RaanPhasing'
    }

    @classmethod
    def get_discriminator_value(cls, obj: Dict[str, Any]) -> Optional[str]:
        """Returns the discriminator value (object type) of the data"""
        discriminator_value = obj[cls.__discriminator_property_name]
        if discriminator_value:
            return cls.__discriminator_value_class_map.get(discriminator_value)
        else:
            return None

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Union[Deorbitation, LeoStationKeeping, OrbitalTransfer, OrbitPhasing, OrbitPropagation, RaanPhasing]]:
        """Create an instance of Maneuver from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Dict[str, Any]) -> Optional[Union[Deorbitation, LeoStationKeeping, OrbitalTransfer, OrbitPhasing, OrbitPropagation, RaanPhasing]]:
        """Create an instance of Maneuver from a dict"""
        # look up the object type based on discriminator mapping
        object_type = cls.get_discriminator_value(obj)
        if object_type ==  'DEORBITATION':
            return import_module("spacestudio_satellite_client.models.deorbitation").Deorbitation.from_dict(obj)
        if object_type ==  'LEO_STATION_KEEPING':
            return import_module("spacestudio_satellite_client.models.leo_station_keeping").LeoStationKeeping.from_dict(obj)
        if object_type ==  'ORBITAL_TRANSFER':
            return import_module("spacestudio_satellite_client.models.orbital_transfer").OrbitalTransfer.from_dict(obj)
        if object_type ==  'ORBIT_PHASING':
            return import_module("spacestudio_satellite_client.models.orbit_phasing").OrbitPhasing.from_dict(obj)
        if object_type ==  'ORBIT_PROPAGATION':
            return import_module("spacestudio_satellite_client.models.orbit_propagation").OrbitPropagation.from_dict(obj)
        if object_type ==  'RAAN_PHASING':
            return import_module("spacestudio_satellite_client.models.raan_phasing").RaanPhasing.from_dict(obj)

        raise ValueError("Maneuver failed to lookup discriminator value from " +
                            json.dumps(obj) + ". Discriminator property name: " + cls.__discriminator_property_name +
                            ", mapping: " + json.dumps(cls.__discriminator_value_class_map))


