# coding: utf-8

"""
    spacestudio satellite API documentation

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: 1.0.13
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import ConfigDict, Field, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional, Union
from spacestudio_satellite_client.models.maneuver import Maneuver
from typing import Optional, Set
from typing_extensions import Self

class OrbitPhasing(Maneuver):
    """
    OrbitPhasing
    """ # noqa: E501
    target_mission_duration_for_aol: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The target mission duration for AOL.", alias="targetMissionDurationForAol")
    target_delta_argument_of_latitude: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The target delta argument of latitude.", alias="targetDeltaArgumentOfLatitude")
    target_delta_vmax: Optional[Union[StrictFloat, StrictInt]] = Field(default=None, description="The target delta Vmax.", alias="targetDeltaVmax")
    optimization_type: Optional[StrictStr] = Field(default=None, description="The type of optimization to perform.", alias="optimizationType")
    __properties: ClassVar[List[str]] = ["type", "targetMissionDurationForAol", "targetDeltaArgumentOfLatitude", "targetDeltaVmax", "optimizationType"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrbitPhasing from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrbitPhasing from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "type": obj.get("type"),
            "targetMissionDurationForAol": obj.get("targetMissionDurationForAol"),
            "targetDeltaArgumentOfLatitude": obj.get("targetDeltaArgumentOfLatitude"),
            "targetDeltaVmax": obj.get("targetDeltaVmax"),
            "optimizationType": obj.get("optimizationType")
        })
        return _obj


